package com.trust.ywx.customer.common.enu;
/***************************************************************************
 * <pre></pre>
 * @文件名称:  CachannelEnum.java
 * @包   路   径：  cn.org.bjca.ywq.firm.cons
 * @版权所有：北京数字认证股份有限公司 (C) 2018
 *
 * @类描述:
 * @版本: V1.5
 * @创建人： wujunpeng
 * @创建时间：2021年3月9日 下午7:36:58
 *
 * @修改记录：
 **/
public enum CaChannelEnum {
    BJCA(0,"北京ca","北京数字认证股份有限公司"),
    SZCA(1,"深圳ca","深圳ca"),
    GXCA(2,"广西ca","广西壮族自治区数字证书认证中心有限公司"),
    XJCA(3,"新疆ca","新疆数字证书认证中心")
    ;

    private int channel;
    private String dec;
    private String orgName;

    CaChannelEnum(int channel, String dec, String orgName) {
        this.channel = channel;
        this.dec = dec;
        this.orgName = orgName;
    }

    // 普通方法
    public static String getDes(int type) {
        for (CaChannelEnum t : CaChannelEnum.values()) {
            if (t.getChannel() == type) {
                return t.getDec();
            }
        }
        return null;
    }

    public static String getOrgName(int type) {
        for (CaChannelEnum t : CaChannelEnum.values()) {
            if (t.getChannel() == type) {
                return t.getOrgName();
            }
        }
        return null;
    }
    public String getOrgName() {
        return orgName;
    }

    public int getChannel() {
        return channel;
    }


    public String getDec() {
        return dec;
    }
}
