package com.trust.ywx.customer.common.enu;

/**
 * <pre></pre>
 *
 * @文件名称： Firm.java
 * @包 路  径： com.trust.ywx.customer.common.enums
 * @Copyright：北京数字医信责任有限公司 (C) 2022 *
 * @Description: 目前数据库中存的是code（varchar），希望以后改成tinyint
 * @Version: V1.0
 * @Author： hanzhenchao
 * @Date：2022/6/16 13:31
 * @Modify：
 */
public enum ChargingModeEnum {
    NORMAL(0, "规则计费"),
    ERROR(1, "异常计费"),
    ;

    private int code;
    private String name;

    private ChargingModeEnum(int code, String name) {
        this.code = code;
        this.name = name;
    }
    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }
}
