package com.trust.ywx.customer.common.model.manager.response;

import lombok.Data;

import java.util.Date;

/**
 * <pre></pre>
 *
 * @文件名称： AuditCustomerDto.java
 * @包 路  径： com.trust.ywx.customer.service.dto
 * @Copyright：北京数字医信责任有限公司 (C) 2022 *
 * @Description:
 * @Version: V1.0
 * @Author： hanzhenchao
 * @Date：2022/6/14 20:15
 * @Modify：
 */
@Data
public class TrustFirmDto{
    /**
     * 客户主键
     */
    private String uniqueid;
    /**
     * 客户id
     */
    private String clientId;
    /**
     * 客户名称
     */
    private String firmName;

    /**
     * 审核状态
     */
    private String firmStatus;

    /**
     * 第三方应用APP_SECRET
     *
     */
    private String appSecret;

    /**
     * 第三方厂商联系电话
     *
     */
    private String firmPhone;

    /**
     * 第三方厂商联系人
     *
     */
    private String firmPerson;

    /**
     * 证书算法 RSA/SM2
     */
    private String certAlg;

    /**
     * 第三方厂商联系地址
     *
     */
    private String firmAddress;

    /**
     * 第三方厂商描述
     *
     */
    private String note;


    /**
     * 企业组织机构号
     *
     */
    private String clientOrgCode;

    /**
     * 信步云appid
     *
     */
    private String msspAppid;

    /**
     * 证书发放厂家
     *
     */
    private String certAgency;

    /**
     * 0 手动制章 1 自动制章
     * 改参数迁移至FirmPropParam.stampType
     */
//    private String stampType;

    /**
     * 外键id
     *
     */
    private String openId;

    /**
     * 审核(医生审核、等)完成之后是否发送短信提示
     * Y-是 N-否
     * 改参数迁移至FirmPropParam.sendSms
     */
//    private String sendSms;

    /**
     * 销售人员id
     *
     */
    private String salePersonId;

    /**
     * 技术支持
     *
     */
    private String techPersonId;

    /**
     * 创建
     *
     */
    private Date createTime;

    /**
     * 修改时间
     */
    private Date updateTime;

    /**
     * 代理厂商id
     */
    private String agentClientId;

    /**
     * 代理商销售
     *
     */
    private String agentSaleId;

    /**
     * CA 渠道
     */
    private Integer caChannel;


    /**
     * 数字认证运营平台app_id
     */
    private Integer platAppId;

}
