package com.trust.ywx.customer.commons;

import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Random;
import java.util.UUID;

/**
 * <pre></pre>
 *
 * @文件名称： UniqueIdUtils.java
 * @包 路  径： com.trust.ywx.customer.commons
 * @Copyright：北京数字医信责任有限公司 (C) 2022 *
 * @Description:
 * @Version: V1.0
 * @Author： hanzhenchao
 * @Date：2022/6/21 10:00
 * @Modify：
 */
public class UniqueIdUtils {

    /**
     * 获取表主键
     * 以后会删除此主键，建立一个int类型的数据库自增主键
     * @return
     */
    public static String genrateUniqueId() {
        String uuid = UUID.randomUUID().toString().replace("-", "");
        return uuid;
    }


    /**
     * 获取appSecret
     * @return
     */
    public static String generateAppSecret() {
        return generateClientId();
    }
    /**
     * 获取clientId
     * @return
     */
    public static String generateClientId() {
        SimpleDateFormat sdf = new SimpleDateFormat("yyyyMMddHHmmss");
        Random random = new Random();
        int randInt = random.nextInt(10) * 10;
        if (randInt == 0) {
            randInt = 10;
        }

        randInt += random.nextInt(10);
        return sdf.format(new Date()) + randInt;
    }
}
