//package com.trust.ywx.customer.dao.datasource;
//
//import lombok.extern.slf4j.Slf4j;
//import org.apache.ibatis.session.SqlSessionFactory;
//import org.mybatis.spring.SqlSessionFactoryBean;
//import org.mybatis.spring.SqlSessionTemplate;
//import org.mybatis.spring.annotation.MapperScan;
//import org.springframework.context.annotation.Bean;
//import org.springframework.context.annotation.Configuration;
//import org.springframework.core.io.support.PathMatchingResourcePatternResolver;
//
//import javax.annotation.Resource;
//import javax.sql.DataSource;
//
///**
// * <pre></pre>
// *
// * @文件名称： MyBatisConfigMaster.java
// * @包 路  径： com.trust.ywx.customer.dao.datasource
// * @Copyright：北京数字医信责任有限公司 (C) 2022 *
// * @Description:
// * @Version: V1.0
// * @Author： hanzhenchao
// * @Date：2022/6/15 15:49
// * @Modify：
// */
//@Slf4j
//@Configuration
//@MapperScan(basePackages = "com.trust.ywx.dao.mapper",
//        sqlSessionFactoryRef = "sqlSessionFactory2",
//        sqlSessionTemplateRef = "sqlSessionTemplate2")
//public class MyBatisConfigSlave {
//
//
//    @Resource(name = "slave")
//    DataSource slave;
//
//    @Bean
//    SqlSessionFactory sqlSessionFactory2() {
//        SqlSessionFactory sessionFactory = null;
//        try {
//            SqlSessionFactoryBean bean = new SqlSessionFactoryBean();
//            PathMatchingResourcePatternResolver resolver = new PathMatchingResourcePatternResolver();
//            bean.setDataSource(slave);
//            // 每张表对应的xml文件
//            bean.setMapperLocations(resolver.getResources(("classpath:mybatis/mapper/*/*Mapper.xml")));
//            // 每一张表对应的实体类
//            bean.setTypeAliasesPackage("com.trust.ywx.dao.po");
//            sessionFactory = bean.getObject();
//        } catch (Exception e) {
//            log.error("com.trust.ywx.customer.dao.datasource.MyBatisConfigSlave.sqlSessionFactory2",e);
//        }
//        return sessionFactory;
//    }
//    @Bean
//    SqlSessionTemplate sqlSessionTemplate2() {
//        return new SqlSessionTemplate(sqlSessionFactory2());
//    }
//}
