package com.trust.ywx.customer.dao.po;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class FirmInfoExample {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    protected Integer offset;

    protected Integer rows;

    public FirmInfoExample() {
        oredCriteria = new ArrayList<Criteria>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
        rows = null;
        offset = null;
    }

    public void setOffset(Integer offset) {
        this.offset = offset;
    }

    public Integer getOffset() {
        return this.offset;
    }

    public void setRows(Integer rows) {
        this.rows = rows;
    }

    public Integer getRows() {
        return this.rows;
    }

    public FirmInfoExample limit(Integer rows) {
        this.rows = rows;
        return this;
    }

    public FirmInfoExample limit(Integer offset, Integer rows) {
        this.offset = offset;
        this.rows = rows;
        return this;
    }

    public FirmInfoExample page(Integer page, Integer pageSize) {
        this.offset = page * pageSize;
        this.rows = pageSize;
        return this;
    }

    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andUniqueidIsNull() {
            addCriterion("uniqueid is null");
            return (Criteria) this;
        }

        public Criteria andUniqueidIsNotNull() {
            addCriterion("uniqueid is not null");
            return (Criteria) this;
        }

        public Criteria andUniqueidEqualTo(String value) {
            addCriterion("uniqueid =", value, "uniqueid");
            return (Criteria) this;
        }

        public Criteria andUniqueidNotEqualTo(String value) {
            addCriterion("uniqueid <>", value, "uniqueid");
            return (Criteria) this;
        }

        public Criteria andUniqueidGreaterThan(String value) {
            addCriterion("uniqueid >", value, "uniqueid");
            return (Criteria) this;
        }

        public Criteria andUniqueidGreaterThanOrEqualTo(String value) {
            addCriterion("uniqueid >=", value, "uniqueid");
            return (Criteria) this;
        }

        public Criteria andUniqueidLessThan(String value) {
            addCriterion("uniqueid <", value, "uniqueid");
            return (Criteria) this;
        }

        public Criteria andUniqueidLessThanOrEqualTo(String value) {
            addCriterion("uniqueid <=", value, "uniqueid");
            return (Criteria) this;
        }

        public Criteria andUniqueidLike(String value) {
            addCriterion("uniqueid like", value, "uniqueid");
            return (Criteria) this;
        }

        public Criteria andUniqueidNotLike(String value) {
            addCriterion("uniqueid not like", value, "uniqueid");
            return (Criteria) this;
        }

        public Criteria andUniqueidIn(List<String> values) {
            addCriterion("uniqueid in", values, "uniqueid");
            return (Criteria) this;
        }

        public Criteria andUniqueidNotIn(List<String> values) {
            addCriterion("uniqueid not in", values, "uniqueid");
            return (Criteria) this;
        }

        public Criteria andUniqueidBetween(String value1, String value2) {
            addCriterion("uniqueid between", value1, value2, "uniqueid");
            return (Criteria) this;
        }

        public Criteria andUniqueidNotBetween(String value1, String value2) {
            addCriterion("uniqueid not between", value1, value2, "uniqueid");
            return (Criteria) this;
        }

        public Criteria andClientIdIsNull() {
            addCriterion("client_id is null");
            return (Criteria) this;
        }

        public Criteria andClientIdIsNotNull() {
            addCriterion("client_id is not null");
            return (Criteria) this;
        }

        public Criteria andClientIdEqualTo(String value) {
            addCriterion("client_id =", value, "clientId");
            return (Criteria) this;
        }

        public Criteria andClientIdNotEqualTo(String value) {
            addCriterion("client_id <>", value, "clientId");
            return (Criteria) this;
        }

        public Criteria andClientIdGreaterThan(String value) {
            addCriterion("client_id >", value, "clientId");
            return (Criteria) this;
        }

        public Criteria andClientIdGreaterThanOrEqualTo(String value) {
            addCriterion("client_id >=", value, "clientId");
            return (Criteria) this;
        }

        public Criteria andClientIdLessThan(String value) {
            addCriterion("client_id <", value, "clientId");
            return (Criteria) this;
        }

        public Criteria andClientIdLessThanOrEqualTo(String value) {
            addCriterion("client_id <=", value, "clientId");
            return (Criteria) this;
        }

        public Criteria andClientIdLike(String value) {
            addCriterion("client_id like", value, "clientId");
            return (Criteria) this;
        }

        public Criteria andClientIdNotLike(String value) {
            addCriterion("client_id not like", value, "clientId");
            return (Criteria) this;
        }

        public Criteria andClientIdIn(List<String> values) {
            addCriterion("client_id in", values, "clientId");
            return (Criteria) this;
        }

        public Criteria andClientIdNotIn(List<String> values) {
            addCriterion("client_id not in", values, "clientId");
            return (Criteria) this;
        }

        public Criteria andClientIdBetween(String value1, String value2) {
            addCriterion("client_id between", value1, value2, "clientId");
            return (Criteria) this;
        }

        public Criteria andClientIdNotBetween(String value1, String value2) {
            addCriterion("client_id not between", value1, value2, "clientId");
            return (Criteria) this;
        }

        public Criteria andFirmPersonIsNull() {
            addCriterion("firm_person is null");
            return (Criteria) this;
        }

        public Criteria andFirmPersonIsNotNull() {
            addCriterion("firm_person is not null");
            return (Criteria) this;
        }

        public Criteria andFirmPersonEqualTo(String value) {
            addCriterion("firm_person =", value, "firmPerson");
            return (Criteria) this;
        }

        public Criteria andFirmPersonNotEqualTo(String value) {
            addCriterion("firm_person <>", value, "firmPerson");
            return (Criteria) this;
        }

        public Criteria andFirmPersonGreaterThan(String value) {
            addCriterion("firm_person >", value, "firmPerson");
            return (Criteria) this;
        }

        public Criteria andFirmPersonGreaterThanOrEqualTo(String value) {
            addCriterion("firm_person >=", value, "firmPerson");
            return (Criteria) this;
        }

        public Criteria andFirmPersonLessThan(String value) {
            addCriterion("firm_person <", value, "firmPerson");
            return (Criteria) this;
        }

        public Criteria andFirmPersonLessThanOrEqualTo(String value) {
            addCriterion("firm_person <=", value, "firmPerson");
            return (Criteria) this;
        }

        public Criteria andFirmPersonLike(String value) {
            addCriterion("firm_person like", value, "firmPerson");
            return (Criteria) this;
        }

        public Criteria andFirmPersonNotLike(String value) {
            addCriterion("firm_person not like", value, "firmPerson");
            return (Criteria) this;
        }

        public Criteria andFirmPersonIn(List<String> values) {
            addCriterion("firm_person in", values, "firmPerson");
            return (Criteria) this;
        }

        public Criteria andFirmPersonNotIn(List<String> values) {
            addCriterion("firm_person not in", values, "firmPerson");
            return (Criteria) this;
        }

        public Criteria andFirmPersonBetween(String value1, String value2) {
            addCriterion("firm_person between", value1, value2, "firmPerson");
            return (Criteria) this;
        }

        public Criteria andFirmPersonNotBetween(String value1, String value2) {
            addCriterion("firm_person not between", value1, value2, "firmPerson");
            return (Criteria) this;
        }

        public Criteria andAppSecretIsNull() {
            addCriterion("app_secret is null");
            return (Criteria) this;
        }

        public Criteria andAppSecretIsNotNull() {
            addCriterion("app_secret is not null");
            return (Criteria) this;
        }

        public Criteria andAppSecretEqualTo(String value) {
            addCriterion("app_secret =", value, "appSecret");
            return (Criteria) this;
        }

        public Criteria andAppSecretNotEqualTo(String value) {
            addCriterion("app_secret <>", value, "appSecret");
            return (Criteria) this;
        }

        public Criteria andAppSecretGreaterThan(String value) {
            addCriterion("app_secret >", value, "appSecret");
            return (Criteria) this;
        }

        public Criteria andAppSecretGreaterThanOrEqualTo(String value) {
            addCriterion("app_secret >=", value, "appSecret");
            return (Criteria) this;
        }

        public Criteria andAppSecretLessThan(String value) {
            addCriterion("app_secret <", value, "appSecret");
            return (Criteria) this;
        }

        public Criteria andAppSecretLessThanOrEqualTo(String value) {
            addCriterion("app_secret <=", value, "appSecret");
            return (Criteria) this;
        }

        public Criteria andAppSecretLike(String value) {
            addCriterion("app_secret like", value, "appSecret");
            return (Criteria) this;
        }

        public Criteria andAppSecretNotLike(String value) {
            addCriterion("app_secret not like", value, "appSecret");
            return (Criteria) this;
        }

        public Criteria andAppSecretIn(List<String> values) {
            addCriterion("app_secret in", values, "appSecret");
            return (Criteria) this;
        }

        public Criteria andAppSecretNotIn(List<String> values) {
            addCriterion("app_secret not in", values, "appSecret");
            return (Criteria) this;
        }

        public Criteria andAppSecretBetween(String value1, String value2) {
            addCriterion("app_secret between", value1, value2, "appSecret");
            return (Criteria) this;
        }

        public Criteria andAppSecretNotBetween(String value1, String value2) {
            addCriterion("app_secret not between", value1, value2, "appSecret");
            return (Criteria) this;
        }

        public Criteria andFirmNameIsNull() {
            addCriterion("firm_name is null");
            return (Criteria) this;
        }

        public Criteria andFirmNameIsNotNull() {
            addCriterion("firm_name is not null");
            return (Criteria) this;
        }

        public Criteria andFirmNameEqualTo(String value) {
            addCriterion("firm_name =", value, "firmName");
            return (Criteria) this;
        }

        public Criteria andFirmNameNotEqualTo(String value) {
            addCriterion("firm_name <>", value, "firmName");
            return (Criteria) this;
        }

        public Criteria andFirmNameGreaterThan(String value) {
            addCriterion("firm_name >", value, "firmName");
            return (Criteria) this;
        }

        public Criteria andFirmNameGreaterThanOrEqualTo(String value) {
            addCriterion("firm_name >=", value, "firmName");
            return (Criteria) this;
        }

        public Criteria andFirmNameLessThan(String value) {
            addCriterion("firm_name <", value, "firmName");
            return (Criteria) this;
        }

        public Criteria andFirmNameLessThanOrEqualTo(String value) {
            addCriterion("firm_name <=", value, "firmName");
            return (Criteria) this;
        }

        public Criteria andFirmNameLike(String value) {
            addCriterion("firm_name like", value, "firmName");
            return (Criteria) this;
        }

        public Criteria andFirmNameNotLike(String value) {
            addCriterion("firm_name not like", value, "firmName");
            return (Criteria) this;
        }

        public Criteria andFirmNameIn(List<String> values) {
            addCriterion("firm_name in", values, "firmName");
            return (Criteria) this;
        }

        public Criteria andFirmNameNotIn(List<String> values) {
            addCriterion("firm_name not in", values, "firmName");
            return (Criteria) this;
        }

        public Criteria andFirmNameBetween(String value1, String value2) {
            addCriterion("firm_name between", value1, value2, "firmName");
            return (Criteria) this;
        }

        public Criteria andFirmNameNotBetween(String value1, String value2) {
            addCriterion("firm_name not between", value1, value2, "firmName");
            return (Criteria) this;
        }

        public Criteria andFirmPhoneIsNull() {
            addCriterion("firm_phone is null");
            return (Criteria) this;
        }

        public Criteria andFirmPhoneIsNotNull() {
            addCriterion("firm_phone is not null");
            return (Criteria) this;
        }

        public Criteria andFirmPhoneEqualTo(String value) {
            addCriterion("firm_phone =", value, "firmPhone");
            return (Criteria) this;
        }

        public Criteria andFirmPhoneNotEqualTo(String value) {
            addCriterion("firm_phone <>", value, "firmPhone");
            return (Criteria) this;
        }

        public Criteria andFirmPhoneGreaterThan(String value) {
            addCriterion("firm_phone >", value, "firmPhone");
            return (Criteria) this;
        }

        public Criteria andFirmPhoneGreaterThanOrEqualTo(String value) {
            addCriterion("firm_phone >=", value, "firmPhone");
            return (Criteria) this;
        }

        public Criteria andFirmPhoneLessThan(String value) {
            addCriterion("firm_phone <", value, "firmPhone");
            return (Criteria) this;
        }

        public Criteria andFirmPhoneLessThanOrEqualTo(String value) {
            addCriterion("firm_phone <=", value, "firmPhone");
            return (Criteria) this;
        }

        public Criteria andFirmPhoneLike(String value) {
            addCriterion("firm_phone like", value, "firmPhone");
            return (Criteria) this;
        }

        public Criteria andFirmPhoneNotLike(String value) {
            addCriterion("firm_phone not like", value, "firmPhone");
            return (Criteria) this;
        }

        public Criteria andFirmPhoneIn(List<String> values) {
            addCriterion("firm_phone in", values, "firmPhone");
            return (Criteria) this;
        }

        public Criteria andFirmPhoneNotIn(List<String> values) {
            addCriterion("firm_phone not in", values, "firmPhone");
            return (Criteria) this;
        }

        public Criteria andFirmPhoneBetween(String value1, String value2) {
            addCriterion("firm_phone between", value1, value2, "firmPhone");
            return (Criteria) this;
        }

        public Criteria andFirmPhoneNotBetween(String value1, String value2) {
            addCriterion("firm_phone not between", value1, value2, "firmPhone");
            return (Criteria) this;
        }

        public Criteria andCertAlgIsNull() {
            addCriterion("cert_alg is null");
            return (Criteria) this;
        }

        public Criteria andCertAlgIsNotNull() {
            addCriterion("cert_alg is not null");
            return (Criteria) this;
        }

        public Criteria andCertAlgEqualTo(String value) {
            addCriterion("cert_alg =", value, "certAlg");
            return (Criteria) this;
        }

        public Criteria andCertAlgNotEqualTo(String value) {
            addCriterion("cert_alg <>", value, "certAlg");
            return (Criteria) this;
        }

        public Criteria andCertAlgGreaterThan(String value) {
            addCriterion("cert_alg >", value, "certAlg");
            return (Criteria) this;
        }

        public Criteria andCertAlgGreaterThanOrEqualTo(String value) {
            addCriterion("cert_alg >=", value, "certAlg");
            return (Criteria) this;
        }

        public Criteria andCertAlgLessThan(String value) {
            addCriterion("cert_alg <", value, "certAlg");
            return (Criteria) this;
        }

        public Criteria andCertAlgLessThanOrEqualTo(String value) {
            addCriterion("cert_alg <=", value, "certAlg");
            return (Criteria) this;
        }

        public Criteria andCertAlgLike(String value) {
            addCriterion("cert_alg like", value, "certAlg");
            return (Criteria) this;
        }

        public Criteria andCertAlgNotLike(String value) {
            addCriterion("cert_alg not like", value, "certAlg");
            return (Criteria) this;
        }

        public Criteria andCertAlgIn(List<String> values) {
            addCriterion("cert_alg in", values, "certAlg");
            return (Criteria) this;
        }

        public Criteria andCertAlgNotIn(List<String> values) {
            addCriterion("cert_alg not in", values, "certAlg");
            return (Criteria) this;
        }

        public Criteria andCertAlgBetween(String value1, String value2) {
            addCriterion("cert_alg between", value1, value2, "certAlg");
            return (Criteria) this;
        }

        public Criteria andCertAlgNotBetween(String value1, String value2) {
            addCriterion("cert_alg not between", value1, value2, "certAlg");
            return (Criteria) this;
        }

        public Criteria andFirmAddressIsNull() {
            addCriterion("firm_address is null");
            return (Criteria) this;
        }

        public Criteria andFirmAddressIsNotNull() {
            addCriterion("firm_address is not null");
            return (Criteria) this;
        }

        public Criteria andFirmAddressEqualTo(String value) {
            addCriterion("firm_address =", value, "firmAddress");
            return (Criteria) this;
        }

        public Criteria andFirmAddressNotEqualTo(String value) {
            addCriterion("firm_address <>", value, "firmAddress");
            return (Criteria) this;
        }

        public Criteria andFirmAddressGreaterThan(String value) {
            addCriterion("firm_address >", value, "firmAddress");
            return (Criteria) this;
        }

        public Criteria andFirmAddressGreaterThanOrEqualTo(String value) {
            addCriterion("firm_address >=", value, "firmAddress");
            return (Criteria) this;
        }

        public Criteria andFirmAddressLessThan(String value) {
            addCriterion("firm_address <", value, "firmAddress");
            return (Criteria) this;
        }

        public Criteria andFirmAddressLessThanOrEqualTo(String value) {
            addCriterion("firm_address <=", value, "firmAddress");
            return (Criteria) this;
        }

        public Criteria andFirmAddressLike(String value) {
            addCriterion("firm_address like", value, "firmAddress");
            return (Criteria) this;
        }

        public Criteria andFirmAddressNotLike(String value) {
            addCriterion("firm_address not like", value, "firmAddress");
            return (Criteria) this;
        }

        public Criteria andFirmAddressIn(List<String> values) {
            addCriterion("firm_address in", values, "firmAddress");
            return (Criteria) this;
        }

        public Criteria andFirmAddressNotIn(List<String> values) {
            addCriterion("firm_address not in", values, "firmAddress");
            return (Criteria) this;
        }

        public Criteria andFirmAddressBetween(String value1, String value2) {
            addCriterion("firm_address between", value1, value2, "firmAddress");
            return (Criteria) this;
        }

        public Criteria andFirmAddressNotBetween(String value1, String value2) {
            addCriterion("firm_address not between", value1, value2, "firmAddress");
            return (Criteria) this;
        }

        public Criteria andNoteIsNull() {
            addCriterion("note is null");
            return (Criteria) this;
        }

        public Criteria andNoteIsNotNull() {
            addCriterion("note is not null");
            return (Criteria) this;
        }

        public Criteria andNoteEqualTo(String value) {
            addCriterion("note =", value, "note");
            return (Criteria) this;
        }

        public Criteria andNoteNotEqualTo(String value) {
            addCriterion("note <>", value, "note");
            return (Criteria) this;
        }

        public Criteria andNoteGreaterThan(String value) {
            addCriterion("note >", value, "note");
            return (Criteria) this;
        }

        public Criteria andNoteGreaterThanOrEqualTo(String value) {
            addCriterion("note >=", value, "note");
            return (Criteria) this;
        }

        public Criteria andNoteLessThan(String value) {
            addCriterion("note <", value, "note");
            return (Criteria) this;
        }

        public Criteria andNoteLessThanOrEqualTo(String value) {
            addCriterion("note <=", value, "note");
            return (Criteria) this;
        }

        public Criteria andNoteLike(String value) {
            addCriterion("note like", value, "note");
            return (Criteria) this;
        }

        public Criteria andNoteNotLike(String value) {
            addCriterion("note not like", value, "note");
            return (Criteria) this;
        }

        public Criteria andNoteIn(List<String> values) {
            addCriterion("note in", values, "note");
            return (Criteria) this;
        }

        public Criteria andNoteNotIn(List<String> values) {
            addCriterion("note not in", values, "note");
            return (Criteria) this;
        }

        public Criteria andNoteBetween(String value1, String value2) {
            addCriterion("note between", value1, value2, "note");
            return (Criteria) this;
        }

        public Criteria andNoteNotBetween(String value1, String value2) {
            addCriterion("note not between", value1, value2, "note");
            return (Criteria) this;
        }

        public Criteria andFirmEmailIsNull() {
            addCriterion("firm_email is null");
            return (Criteria) this;
        }

        public Criteria andFirmEmailIsNotNull() {
            addCriterion("firm_email is not null");
            return (Criteria) this;
        }

        public Criteria andFirmEmailEqualTo(String value) {
            addCriterion("firm_email =", value, "firmEmail");
            return (Criteria) this;
        }

        public Criteria andFirmEmailNotEqualTo(String value) {
            addCriterion("firm_email <>", value, "firmEmail");
            return (Criteria) this;
        }

        public Criteria andFirmEmailGreaterThan(String value) {
            addCriterion("firm_email >", value, "firmEmail");
            return (Criteria) this;
        }

        public Criteria andFirmEmailGreaterThanOrEqualTo(String value) {
            addCriterion("firm_email >=", value, "firmEmail");
            return (Criteria) this;
        }

        public Criteria andFirmEmailLessThan(String value) {
            addCriterion("firm_email <", value, "firmEmail");
            return (Criteria) this;
        }

        public Criteria andFirmEmailLessThanOrEqualTo(String value) {
            addCriterion("firm_email <=", value, "firmEmail");
            return (Criteria) this;
        }

        public Criteria andFirmEmailLike(String value) {
            addCriterion("firm_email like", value, "firmEmail");
            return (Criteria) this;
        }

        public Criteria andFirmEmailNotLike(String value) {
            addCriterion("firm_email not like", value, "firmEmail");
            return (Criteria) this;
        }

        public Criteria andFirmEmailIn(List<String> values) {
            addCriterion("firm_email in", values, "firmEmail");
            return (Criteria) this;
        }

        public Criteria andFirmEmailNotIn(List<String> values) {
            addCriterion("firm_email not in", values, "firmEmail");
            return (Criteria) this;
        }

        public Criteria andFirmEmailBetween(String value1, String value2) {
            addCriterion("firm_email between", value1, value2, "firmEmail");
            return (Criteria) this;
        }

        public Criteria andFirmEmailNotBetween(String value1, String value2) {
            addCriterion("firm_email not between", value1, value2, "firmEmail");
            return (Criteria) this;
        }

        public Criteria andStatusIsNull() {
            addCriterion("status is null");
            return (Criteria) this;
        }

        public Criteria andStatusIsNotNull() {
            addCriterion("status is not null");
            return (Criteria) this;
        }

        public Criteria andStatusEqualTo(Integer value) {
            addCriterion("status =", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusNotEqualTo(Integer value) {
            addCriterion("status <>", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusGreaterThan(Integer value) {
            addCriterion("status >", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusGreaterThanOrEqualTo(Integer value) {
            addCriterion("status >=", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusLessThan(Integer value) {
            addCriterion("status <", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusLessThanOrEqualTo(Integer value) {
            addCriterion("status <=", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusIn(List<Integer> values) {
            addCriterion("status in", values, "status");
            return (Criteria) this;
        }

        public Criteria andStatusNotIn(List<Integer> values) {
            addCriterion("status not in", values, "status");
            return (Criteria) this;
        }

        public Criteria andStatusBetween(Integer value1, Integer value2) {
            addCriterion("status between", value1, value2, "status");
            return (Criteria) this;
        }

        public Criteria andStatusNotBetween(Integer value1, Integer value2) {
            addCriterion("status not between", value1, value2, "status");
            return (Criteria) this;
        }

        public Criteria andClientOrgCodeIsNull() {
            addCriterion("client_org_code is null");
            return (Criteria) this;
        }

        public Criteria andClientOrgCodeIsNotNull() {
            addCriterion("client_org_code is not null");
            return (Criteria) this;
        }

        public Criteria andClientOrgCodeEqualTo(String value) {
            addCriterion("client_org_code =", value, "clientOrgCode");
            return (Criteria) this;
        }

        public Criteria andClientOrgCodeNotEqualTo(String value) {
            addCriterion("client_org_code <>", value, "clientOrgCode");
            return (Criteria) this;
        }

        public Criteria andClientOrgCodeGreaterThan(String value) {
            addCriterion("client_org_code >", value, "clientOrgCode");
            return (Criteria) this;
        }

        public Criteria andClientOrgCodeGreaterThanOrEqualTo(String value) {
            addCriterion("client_org_code >=", value, "clientOrgCode");
            return (Criteria) this;
        }

        public Criteria andClientOrgCodeLessThan(String value) {
            addCriterion("client_org_code <", value, "clientOrgCode");
            return (Criteria) this;
        }

        public Criteria andClientOrgCodeLessThanOrEqualTo(String value) {
            addCriterion("client_org_code <=", value, "clientOrgCode");
            return (Criteria) this;
        }

        public Criteria andClientOrgCodeLike(String value) {
            addCriterion("client_org_code like", value, "clientOrgCode");
            return (Criteria) this;
        }

        public Criteria andClientOrgCodeNotLike(String value) {
            addCriterion("client_org_code not like", value, "clientOrgCode");
            return (Criteria) this;
        }

        public Criteria andClientOrgCodeIn(List<String> values) {
            addCriterion("client_org_code in", values, "clientOrgCode");
            return (Criteria) this;
        }

        public Criteria andClientOrgCodeNotIn(List<String> values) {
            addCriterion("client_org_code not in", values, "clientOrgCode");
            return (Criteria) this;
        }

        public Criteria andClientOrgCodeBetween(String value1, String value2) {
            addCriterion("client_org_code between", value1, value2, "clientOrgCode");
            return (Criteria) this;
        }

        public Criteria andClientOrgCodeNotBetween(String value1, String value2) {
            addCriterion("client_org_code not between", value1, value2, "clientOrgCode");
            return (Criteria) this;
        }

        public Criteria andMsspAppidIsNull() {
            addCriterion("mssp_appid is null");
            return (Criteria) this;
        }

        public Criteria andMsspAppidIsNotNull() {
            addCriterion("mssp_appid is not null");
            return (Criteria) this;
        }

        public Criteria andMsspAppidEqualTo(String value) {
            addCriterion("mssp_appid =", value, "msspAppid");
            return (Criteria) this;
        }

        public Criteria andMsspAppidNotEqualTo(String value) {
            addCriterion("mssp_appid <>", value, "msspAppid");
            return (Criteria) this;
        }

        public Criteria andMsspAppidGreaterThan(String value) {
            addCriterion("mssp_appid >", value, "msspAppid");
            return (Criteria) this;
        }

        public Criteria andMsspAppidGreaterThanOrEqualTo(String value) {
            addCriterion("mssp_appid >=", value, "msspAppid");
            return (Criteria) this;
        }

        public Criteria andMsspAppidLessThan(String value) {
            addCriterion("mssp_appid <", value, "msspAppid");
            return (Criteria) this;
        }

        public Criteria andMsspAppidLessThanOrEqualTo(String value) {
            addCriterion("mssp_appid <=", value, "msspAppid");
            return (Criteria) this;
        }

        public Criteria andMsspAppidLike(String value) {
            addCriterion("mssp_appid like", value, "msspAppid");
            return (Criteria) this;
        }

        public Criteria andMsspAppidNotLike(String value) {
            addCriterion("mssp_appid not like", value, "msspAppid");
            return (Criteria) this;
        }

        public Criteria andMsspAppidIn(List<String> values) {
            addCriterion("mssp_appid in", values, "msspAppid");
            return (Criteria) this;
        }

        public Criteria andMsspAppidNotIn(List<String> values) {
            addCriterion("mssp_appid not in", values, "msspAppid");
            return (Criteria) this;
        }

        public Criteria andMsspAppidBetween(String value1, String value2) {
            addCriterion("mssp_appid between", value1, value2, "msspAppid");
            return (Criteria) this;
        }

        public Criteria andMsspAppidNotBetween(String value1, String value2) {
            addCriterion("mssp_appid not between", value1, value2, "msspAppid");
            return (Criteria) this;
        }

        public Criteria andCertAgencyIsNull() {
            addCriterion("cert_agency is null");
            return (Criteria) this;
        }

        public Criteria andCertAgencyIsNotNull() {
            addCriterion("cert_agency is not null");
            return (Criteria) this;
        }

        public Criteria andCertAgencyEqualTo(String value) {
            addCriterion("cert_agency =", value, "certAgency");
            return (Criteria) this;
        }

        public Criteria andCertAgencyNotEqualTo(String value) {
            addCriterion("cert_agency <>", value, "certAgency");
            return (Criteria) this;
        }

        public Criteria andCertAgencyGreaterThan(String value) {
            addCriterion("cert_agency >", value, "certAgency");
            return (Criteria) this;
        }

        public Criteria andCertAgencyGreaterThanOrEqualTo(String value) {
            addCriterion("cert_agency >=", value, "certAgency");
            return (Criteria) this;
        }

        public Criteria andCertAgencyLessThan(String value) {
            addCriterion("cert_agency <", value, "certAgency");
            return (Criteria) this;
        }

        public Criteria andCertAgencyLessThanOrEqualTo(String value) {
            addCriterion("cert_agency <=", value, "certAgency");
            return (Criteria) this;
        }

        public Criteria andCertAgencyLike(String value) {
            addCriterion("cert_agency like", value, "certAgency");
            return (Criteria) this;
        }

        public Criteria andCertAgencyNotLike(String value) {
            addCriterion("cert_agency not like", value, "certAgency");
            return (Criteria) this;
        }

        public Criteria andCertAgencyIn(List<String> values) {
            addCriterion("cert_agency in", values, "certAgency");
            return (Criteria) this;
        }

        public Criteria andCertAgencyNotIn(List<String> values) {
            addCriterion("cert_agency not in", values, "certAgency");
            return (Criteria) this;
        }

        public Criteria andCertAgencyBetween(String value1, String value2) {
            addCriterion("cert_agency between", value1, value2, "certAgency");
            return (Criteria) this;
        }

        public Criteria andCertAgencyNotBetween(String value1, String value2) {
            addCriterion("cert_agency not between", value1, value2, "certAgency");
            return (Criteria) this;
        }

        public Criteria andStampTypeIsNull() {
            addCriterion("stamp_type is null");
            return (Criteria) this;
        }

        public Criteria andStampTypeIsNotNull() {
            addCriterion("stamp_type is not null");
            return (Criteria) this;
        }

        public Criteria andStampTypeEqualTo(String value) {
            addCriterion("stamp_type =", value, "stampType");
            return (Criteria) this;
        }

        public Criteria andStampTypeNotEqualTo(String value) {
            addCriterion("stamp_type <>", value, "stampType");
            return (Criteria) this;
        }

        public Criteria andStampTypeGreaterThan(String value) {
            addCriterion("stamp_type >", value, "stampType");
            return (Criteria) this;
        }

        public Criteria andStampTypeGreaterThanOrEqualTo(String value) {
            addCriterion("stamp_type >=", value, "stampType");
            return (Criteria) this;
        }

        public Criteria andStampTypeLessThan(String value) {
            addCriterion("stamp_type <", value, "stampType");
            return (Criteria) this;
        }

        public Criteria andStampTypeLessThanOrEqualTo(String value) {
            addCriterion("stamp_type <=", value, "stampType");
            return (Criteria) this;
        }

        public Criteria andStampTypeLike(String value) {
            addCriterion("stamp_type like", value, "stampType");
            return (Criteria) this;
        }

        public Criteria andStampTypeNotLike(String value) {
            addCriterion("stamp_type not like", value, "stampType");
            return (Criteria) this;
        }

        public Criteria andStampTypeIn(List<String> values) {
            addCriterion("stamp_type in", values, "stampType");
            return (Criteria) this;
        }

        public Criteria andStampTypeNotIn(List<String> values) {
            addCriterion("stamp_type not in", values, "stampType");
            return (Criteria) this;
        }

        public Criteria andStampTypeBetween(String value1, String value2) {
            addCriterion("stamp_type between", value1, value2, "stampType");
            return (Criteria) this;
        }

        public Criteria andStampTypeNotBetween(String value1, String value2) {
            addCriterion("stamp_type not between", value1, value2, "stampType");
            return (Criteria) this;
        }

        public Criteria andStampNameIsNull() {
            addCriterion("stamp_name is null");
            return (Criteria) this;
        }

        public Criteria andStampNameIsNotNull() {
            addCriterion("stamp_name is not null");
            return (Criteria) this;
        }

        public Criteria andStampNameEqualTo(String value) {
            addCriterion("stamp_name =", value, "stampName");
            return (Criteria) this;
        }

        public Criteria andStampNameNotEqualTo(String value) {
            addCriterion("stamp_name <>", value, "stampName");
            return (Criteria) this;
        }

        public Criteria andStampNameGreaterThan(String value) {
            addCriterion("stamp_name >", value, "stampName");
            return (Criteria) this;
        }

        public Criteria andStampNameGreaterThanOrEqualTo(String value) {
            addCriterion("stamp_name >=", value, "stampName");
            return (Criteria) this;
        }

        public Criteria andStampNameLessThan(String value) {
            addCriterion("stamp_name <", value, "stampName");
            return (Criteria) this;
        }

        public Criteria andStampNameLessThanOrEqualTo(String value) {
            addCriterion("stamp_name <=", value, "stampName");
            return (Criteria) this;
        }

        public Criteria andStampNameLike(String value) {
            addCriterion("stamp_name like", value, "stampName");
            return (Criteria) this;
        }

        public Criteria andStampNameNotLike(String value) {
            addCriterion("stamp_name not like", value, "stampName");
            return (Criteria) this;
        }

        public Criteria andStampNameIn(List<String> values) {
            addCriterion("stamp_name in", values, "stampName");
            return (Criteria) this;
        }

        public Criteria andStampNameNotIn(List<String> values) {
            addCriterion("stamp_name not in", values, "stampName");
            return (Criteria) this;
        }

        public Criteria andStampNameBetween(String value1, String value2) {
            addCriterion("stamp_name between", value1, value2, "stampName");
            return (Criteria) this;
        }

        public Criteria andStampNameNotBetween(String value1, String value2) {
            addCriterion("stamp_name not between", value1, value2, "stampName");
            return (Criteria) this;
        }

        public Criteria andOpenIdIsNull() {
            addCriterion("open_id is null");
            return (Criteria) this;
        }

        public Criteria andOpenIdIsNotNull() {
            addCriterion("open_id is not null");
            return (Criteria) this;
        }

        public Criteria andOpenIdEqualTo(String value) {
            addCriterion("open_id =", value, "openId");
            return (Criteria) this;
        }

        public Criteria andOpenIdNotEqualTo(String value) {
            addCriterion("open_id <>", value, "openId");
            return (Criteria) this;
        }

        public Criteria andOpenIdGreaterThan(String value) {
            addCriterion("open_id >", value, "openId");
            return (Criteria) this;
        }

        public Criteria andOpenIdGreaterThanOrEqualTo(String value) {
            addCriterion("open_id >=", value, "openId");
            return (Criteria) this;
        }

        public Criteria andOpenIdLessThan(String value) {
            addCriterion("open_id <", value, "openId");
            return (Criteria) this;
        }

        public Criteria andOpenIdLessThanOrEqualTo(String value) {
            addCriterion("open_id <=", value, "openId");
            return (Criteria) this;
        }

        public Criteria andOpenIdLike(String value) {
            addCriterion("open_id like", value, "openId");
            return (Criteria) this;
        }

        public Criteria andOpenIdNotLike(String value) {
            addCriterion("open_id not like", value, "openId");
            return (Criteria) this;
        }

        public Criteria andOpenIdIn(List<String> values) {
            addCriterion("open_id in", values, "openId");
            return (Criteria) this;
        }

        public Criteria andOpenIdNotIn(List<String> values) {
            addCriterion("open_id not in", values, "openId");
            return (Criteria) this;
        }

        public Criteria andOpenIdBetween(String value1, String value2) {
            addCriterion("open_id between", value1, value2, "openId");
            return (Criteria) this;
        }

        public Criteria andOpenIdNotBetween(String value1, String value2) {
            addCriterion("open_id not between", value1, value2, "openId");
            return (Criteria) this;
        }

        public Criteria andSendSmsIsNull() {
            addCriterion("send_sms is null");
            return (Criteria) this;
        }

        public Criteria andSendSmsIsNotNull() {
            addCriterion("send_sms is not null");
            return (Criteria) this;
        }

        public Criteria andSendSmsEqualTo(String value) {
            addCriterion("send_sms =", value, "sendSms");
            return (Criteria) this;
        }

        public Criteria andSendSmsNotEqualTo(String value) {
            addCriterion("send_sms <>", value, "sendSms");
            return (Criteria) this;
        }

        public Criteria andSendSmsGreaterThan(String value) {
            addCriterion("send_sms >", value, "sendSms");
            return (Criteria) this;
        }

        public Criteria andSendSmsGreaterThanOrEqualTo(String value) {
            addCriterion("send_sms >=", value, "sendSms");
            return (Criteria) this;
        }

        public Criteria andSendSmsLessThan(String value) {
            addCriterion("send_sms <", value, "sendSms");
            return (Criteria) this;
        }

        public Criteria andSendSmsLessThanOrEqualTo(String value) {
            addCriterion("send_sms <=", value, "sendSms");
            return (Criteria) this;
        }

        public Criteria andSendSmsLike(String value) {
            addCriterion("send_sms like", value, "sendSms");
            return (Criteria) this;
        }

        public Criteria andSendSmsNotLike(String value) {
            addCriterion("send_sms not like", value, "sendSms");
            return (Criteria) this;
        }

        public Criteria andSendSmsIn(List<String> values) {
            addCriterion("send_sms in", values, "sendSms");
            return (Criteria) this;
        }

        public Criteria andSendSmsNotIn(List<String> values) {
            addCriterion("send_sms not in", values, "sendSms");
            return (Criteria) this;
        }

        public Criteria andSendSmsBetween(String value1, String value2) {
            addCriterion("send_sms between", value1, value2, "sendSms");
            return (Criteria) this;
        }

        public Criteria andSendSmsNotBetween(String value1, String value2) {
            addCriterion("send_sms not between", value1, value2, "sendSms");
            return (Criteria) this;
        }

        public Criteria andSalePersonIdIsNull() {
            addCriterion("sale_person_id is null");
            return (Criteria) this;
        }

        public Criteria andSalePersonIdIsNotNull() {
            addCriterion("sale_person_id is not null");
            return (Criteria) this;
        }

        public Criteria andSalePersonIdEqualTo(String value) {
            addCriterion("sale_person_id =", value, "salePersonId");
            return (Criteria) this;
        }

        public Criteria andSalePersonIdNotEqualTo(String value) {
            addCriterion("sale_person_id <>", value, "salePersonId");
            return (Criteria) this;
        }

        public Criteria andSalePersonIdGreaterThan(String value) {
            addCriterion("sale_person_id >", value, "salePersonId");
            return (Criteria) this;
        }

        public Criteria andSalePersonIdGreaterThanOrEqualTo(String value) {
            addCriterion("sale_person_id >=", value, "salePersonId");
            return (Criteria) this;
        }

        public Criteria andSalePersonIdLessThan(String value) {
            addCriterion("sale_person_id <", value, "salePersonId");
            return (Criteria) this;
        }

        public Criteria andSalePersonIdLessThanOrEqualTo(String value) {
            addCriterion("sale_person_id <=", value, "salePersonId");
            return (Criteria) this;
        }

        public Criteria andSalePersonIdLike(String value) {
            addCriterion("sale_person_id like", value, "salePersonId");
            return (Criteria) this;
        }

        public Criteria andSalePersonIdNotLike(String value) {
            addCriterion("sale_person_id not like", value, "salePersonId");
            return (Criteria) this;
        }

        public Criteria andSalePersonIdIn(List<String> values) {
            addCriterion("sale_person_id in", values, "salePersonId");
            return (Criteria) this;
        }

        public Criteria andSalePersonIdNotIn(List<String> values) {
            addCriterion("sale_person_id not in", values, "salePersonId");
            return (Criteria) this;
        }

        public Criteria andSalePersonIdBetween(String value1, String value2) {
            addCriterion("sale_person_id between", value1, value2, "salePersonId");
            return (Criteria) this;
        }

        public Criteria andSalePersonIdNotBetween(String value1, String value2) {
            addCriterion("sale_person_id not between", value1, value2, "salePersonId");
            return (Criteria) this;
        }

        public Criteria andTechPersonIdIsNull() {
            addCriterion("tech_person_id is null");
            return (Criteria) this;
        }

        public Criteria andTechPersonIdIsNotNull() {
            addCriterion("tech_person_id is not null");
            return (Criteria) this;
        }

        public Criteria andTechPersonIdEqualTo(String value) {
            addCriterion("tech_person_id =", value, "techPersonId");
            return (Criteria) this;
        }

        public Criteria andTechPersonIdNotEqualTo(String value) {
            addCriterion("tech_person_id <>", value, "techPersonId");
            return (Criteria) this;
        }

        public Criteria andTechPersonIdGreaterThan(String value) {
            addCriterion("tech_person_id >", value, "techPersonId");
            return (Criteria) this;
        }

        public Criteria andTechPersonIdGreaterThanOrEqualTo(String value) {
            addCriterion("tech_person_id >=", value, "techPersonId");
            return (Criteria) this;
        }

        public Criteria andTechPersonIdLessThan(String value) {
            addCriterion("tech_person_id <", value, "techPersonId");
            return (Criteria) this;
        }

        public Criteria andTechPersonIdLessThanOrEqualTo(String value) {
            addCriterion("tech_person_id <=", value, "techPersonId");
            return (Criteria) this;
        }

        public Criteria andTechPersonIdLike(String value) {
            addCriterion("tech_person_id like", value, "techPersonId");
            return (Criteria) this;
        }

        public Criteria andTechPersonIdNotLike(String value) {
            addCriterion("tech_person_id not like", value, "techPersonId");
            return (Criteria) this;
        }

        public Criteria andTechPersonIdIn(List<String> values) {
            addCriterion("tech_person_id in", values, "techPersonId");
            return (Criteria) this;
        }

        public Criteria andTechPersonIdNotIn(List<String> values) {
            addCriterion("tech_person_id not in", values, "techPersonId");
            return (Criteria) this;
        }

        public Criteria andTechPersonIdBetween(String value1, String value2) {
            addCriterion("tech_person_id between", value1, value2, "techPersonId");
            return (Criteria) this;
        }

        public Criteria andTechPersonIdNotBetween(String value1, String value2) {
            addCriterion("tech_person_id not between", value1, value2, "techPersonId");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNull() {
            addCriterion("create_time is null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNotNull() {
            addCriterion("create_time is not null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeEqualTo(Date value) {
            addCriterion("create_time =", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotEqualTo(Date value) {
            addCriterion("create_time <>", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThan(Date value) {
            addCriterion("create_time >", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("create_time >=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThan(Date value) {
            addCriterion("create_time <", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThanOrEqualTo(Date value) {
            addCriterion("create_time <=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIn(List<Date> values) {
            addCriterion("create_time in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotIn(List<Date> values) {
            addCriterion("create_time not in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeBetween(Date value1, Date value2) {
            addCriterion("create_time between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotBetween(Date value1, Date value2) {
            addCriterion("create_time not between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIsNull() {
            addCriterion("update_time is null");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIsNotNull() {
            addCriterion("update_time is not null");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeEqualTo(Date value) {
            addCriterion("update_time =", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotEqualTo(Date value) {
            addCriterion("update_time <>", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeGreaterThan(Date value) {
            addCriterion("update_time >", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("update_time >=", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeLessThan(Date value) {
            addCriterion("update_time <", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeLessThanOrEqualTo(Date value) {
            addCriterion("update_time <=", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIn(List<Date> values) {
            addCriterion("update_time in", values, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotIn(List<Date> values) {
            addCriterion("update_time not in", values, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeBetween(Date value1, Date value2) {
            addCriterion("update_time between", value1, value2, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotBetween(Date value1, Date value2) {
            addCriterion("update_time not between", value1, value2, "updateTime");
            return (Criteria) this;
        }

        public Criteria andAgentClientIdIsNull() {
            addCriterion("agent_client_id is null");
            return (Criteria) this;
        }

        public Criteria andAgentClientIdIsNotNull() {
            addCriterion("agent_client_id is not null");
            return (Criteria) this;
        }

        public Criteria andAgentClientIdEqualTo(String value) {
            addCriterion("agent_client_id =", value, "agentClientId");
            return (Criteria) this;
        }

        public Criteria andAgentClientIdNotEqualTo(String value) {
            addCriterion("agent_client_id <>", value, "agentClientId");
            return (Criteria) this;
        }

        public Criteria andAgentClientIdGreaterThan(String value) {
            addCriterion("agent_client_id >", value, "agentClientId");
            return (Criteria) this;
        }

        public Criteria andAgentClientIdGreaterThanOrEqualTo(String value) {
            addCriterion("agent_client_id >=", value, "agentClientId");
            return (Criteria) this;
        }

        public Criteria andAgentClientIdLessThan(String value) {
            addCriterion("agent_client_id <", value, "agentClientId");
            return (Criteria) this;
        }

        public Criteria andAgentClientIdLessThanOrEqualTo(String value) {
            addCriterion("agent_client_id <=", value, "agentClientId");
            return (Criteria) this;
        }

        public Criteria andAgentClientIdLike(String value) {
            addCriterion("agent_client_id like", value, "agentClientId");
            return (Criteria) this;
        }

        public Criteria andAgentClientIdNotLike(String value) {
            addCriterion("agent_client_id not like", value, "agentClientId");
            return (Criteria) this;
        }

        public Criteria andAgentClientIdIn(List<String> values) {
            addCriterion("agent_client_id in", values, "agentClientId");
            return (Criteria) this;
        }

        public Criteria andAgentClientIdNotIn(List<String> values) {
            addCriterion("agent_client_id not in", values, "agentClientId");
            return (Criteria) this;
        }

        public Criteria andAgentClientIdBetween(String value1, String value2) {
            addCriterion("agent_client_id between", value1, value2, "agentClientId");
            return (Criteria) this;
        }

        public Criteria andAgentClientIdNotBetween(String value1, String value2) {
            addCriterion("agent_client_id not between", value1, value2, "agentClientId");
            return (Criteria) this;
        }

        public Criteria andAgentSaleIdIsNull() {
            addCriterion("agent_sale_id is null");
            return (Criteria) this;
        }

        public Criteria andAgentSaleIdIsNotNull() {
            addCriterion("agent_sale_id is not null");
            return (Criteria) this;
        }

        public Criteria andAgentSaleIdEqualTo(String value) {
            addCriterion("agent_sale_id =", value, "agentSaleId");
            return (Criteria) this;
        }

        public Criteria andAgentSaleIdNotEqualTo(String value) {
            addCriterion("agent_sale_id <>", value, "agentSaleId");
            return (Criteria) this;
        }

        public Criteria andAgentSaleIdGreaterThan(String value) {
            addCriterion("agent_sale_id >", value, "agentSaleId");
            return (Criteria) this;
        }

        public Criteria andAgentSaleIdGreaterThanOrEqualTo(String value) {
            addCriterion("agent_sale_id >=", value, "agentSaleId");
            return (Criteria) this;
        }

        public Criteria andAgentSaleIdLessThan(String value) {
            addCriterion("agent_sale_id <", value, "agentSaleId");
            return (Criteria) this;
        }

        public Criteria andAgentSaleIdLessThanOrEqualTo(String value) {
            addCriterion("agent_sale_id <=", value, "agentSaleId");
            return (Criteria) this;
        }

        public Criteria andAgentSaleIdLike(String value) {
            addCriterion("agent_sale_id like", value, "agentSaleId");
            return (Criteria) this;
        }

        public Criteria andAgentSaleIdNotLike(String value) {
            addCriterion("agent_sale_id not like", value, "agentSaleId");
            return (Criteria) this;
        }

        public Criteria andAgentSaleIdIn(List<String> values) {
            addCriterion("agent_sale_id in", values, "agentSaleId");
            return (Criteria) this;
        }

        public Criteria andAgentSaleIdNotIn(List<String> values) {
            addCriterion("agent_sale_id not in", values, "agentSaleId");
            return (Criteria) this;
        }

        public Criteria andAgentSaleIdBetween(String value1, String value2) {
            addCriterion("agent_sale_id between", value1, value2, "agentSaleId");
            return (Criteria) this;
        }

        public Criteria andAgentSaleIdNotBetween(String value1, String value2) {
            addCriterion("agent_sale_id not between", value1, value2, "agentSaleId");
            return (Criteria) this;
        }

        public Criteria andCaChannelIsNull() {
            addCriterion("ca_channel is null");
            return (Criteria) this;
        }

        public Criteria andCaChannelIsNotNull() {
            addCriterion("ca_channel is not null");
            return (Criteria) this;
        }

        public Criteria andCaChannelEqualTo(Integer value) {
            addCriterion("ca_channel =", value, "caChannel");
            return (Criteria) this;
        }

        public Criteria andCaChannelNotEqualTo(Integer value) {
            addCriterion("ca_channel <>", value, "caChannel");
            return (Criteria) this;
        }

        public Criteria andCaChannelGreaterThan(Integer value) {
            addCriterion("ca_channel >", value, "caChannel");
            return (Criteria) this;
        }

        public Criteria andCaChannelGreaterThanOrEqualTo(Integer value) {
            addCriterion("ca_channel >=", value, "caChannel");
            return (Criteria) this;
        }

        public Criteria andCaChannelLessThan(Integer value) {
            addCriterion("ca_channel <", value, "caChannel");
            return (Criteria) this;
        }

        public Criteria andCaChannelLessThanOrEqualTo(Integer value) {
            addCriterion("ca_channel <=", value, "caChannel");
            return (Criteria) this;
        }

        public Criteria andCaChannelIn(List<Integer> values) {
            addCriterion("ca_channel in", values, "caChannel");
            return (Criteria) this;
        }

        public Criteria andCaChannelNotIn(List<Integer> values) {
            addCriterion("ca_channel not in", values, "caChannel");
            return (Criteria) this;
        }

        public Criteria andCaChannelBetween(Integer value1, Integer value2) {
            addCriterion("ca_channel between", value1, value2, "caChannel");
            return (Criteria) this;
        }

        public Criteria andCaChannelNotBetween(Integer value1, Integer value2) {
            addCriterion("ca_channel not between", value1, value2, "caChannel");
            return (Criteria) this;
        }

        public Criteria andProjectStatusIsNull() {
            addCriterion("project_status is null");
            return (Criteria) this;
        }

        public Criteria andProjectStatusIsNotNull() {
            addCriterion("project_status is not null");
            return (Criteria) this;
        }

        public Criteria andProjectStatusEqualTo(Integer value) {
            addCriterion("project_status =", value, "projectStatus");
            return (Criteria) this;
        }

        public Criteria andProjectStatusNotEqualTo(Integer value) {
            addCriterion("project_status <>", value, "projectStatus");
            return (Criteria) this;
        }

        public Criteria andProjectStatusGreaterThan(Integer value) {
            addCriterion("project_status >", value, "projectStatus");
            return (Criteria) this;
        }

        public Criteria andProjectStatusGreaterThanOrEqualTo(Integer value) {
            addCriterion("project_status >=", value, "projectStatus");
            return (Criteria) this;
        }

        public Criteria andProjectStatusLessThan(Integer value) {
            addCriterion("project_status <", value, "projectStatus");
            return (Criteria) this;
        }

        public Criteria andProjectStatusLessThanOrEqualTo(Integer value) {
            addCriterion("project_status <=", value, "projectStatus");
            return (Criteria) this;
        }

        public Criteria andProjectStatusIn(List<Integer> values) {
            addCriterion("project_status in", values, "projectStatus");
            return (Criteria) this;
        }

        public Criteria andProjectStatusNotIn(List<Integer> values) {
            addCriterion("project_status not in", values, "projectStatus");
            return (Criteria) this;
        }

        public Criteria andProjectStatusBetween(Integer value1, Integer value2) {
            addCriterion("project_status between", value1, value2, "projectStatus");
            return (Criteria) this;
        }

        public Criteria andProjectStatusNotBetween(Integer value1, Integer value2) {
            addCriterion("project_status not between", value1, value2, "projectStatus");
            return (Criteria) this;
        }

        public Criteria andPlatAppIdIsNull() {
            addCriterion("plat_app_id is null");
            return (Criteria) this;
        }

        public Criteria andPlatAppIdIsNotNull() {
            addCriterion("plat_app_id is not null");
            return (Criteria) this;
        }

        public Criteria andPlatAppIdEqualTo(Integer value) {
            addCriterion("plat_app_id =", value, "platAppId");
            return (Criteria) this;
        }

        public Criteria andPlatAppIdNotEqualTo(Integer value) {
            addCriterion("plat_app_id <>", value, "platAppId");
            return (Criteria) this;
        }

        public Criteria andPlatAppIdGreaterThan(Integer value) {
            addCriterion("plat_app_id >", value, "platAppId");
            return (Criteria) this;
        }

        public Criteria andPlatAppIdGreaterThanOrEqualTo(Integer value) {
            addCriterion("plat_app_id >=", value, "platAppId");
            return (Criteria) this;
        }

        public Criteria andPlatAppIdLessThan(Integer value) {
            addCriterion("plat_app_id <", value, "platAppId");
            return (Criteria) this;
        }

        public Criteria andPlatAppIdLessThanOrEqualTo(Integer value) {
            addCriterion("plat_app_id <=", value, "platAppId");
            return (Criteria) this;
        }

        public Criteria andPlatAppIdIn(List<Integer> values) {
            addCriterion("plat_app_id in", values, "platAppId");
            return (Criteria) this;
        }

        public Criteria andPlatAppIdNotIn(List<Integer> values) {
            addCriterion("plat_app_id not in", values, "platAppId");
            return (Criteria) this;
        }

        public Criteria andPlatAppIdBetween(Integer value1, Integer value2) {
            addCriterion("plat_app_id between", value1, value2, "platAppId");
            return (Criteria) this;
        }

        public Criteria andPlatAppIdNotBetween(Integer value1, Integer value2) {
            addCriterion("plat_app_id not between", value1, value2, "platAppId");
            return (Criteria) this;
        }
    }

    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}