//package com.trust.ywx.customer.service.impl;
//
//import com.fiftyonetrust.common.model.result.Page;
//import com.fiftyonetrust.common.model.result.PageList;
//import com.trust.ywx.customer.common.enums.FirmProperEnum;
//import com.trust.ywx.customer.common.enums.NetworkTypeEnum;
//import com.trust.ywx.customer.dao.FirmDao;
//import com.trust.ywx.customer.dao.FirmExtendDao;
//import com.trust.ywx.customer.dao.FirmGroupDao;
//import com.trust.ywx.customer.dao.mapper.FirmUsercertChannelMapper;
//import com.trust.ywx.customer.dao.po.FirmInfo;
//import com.trust.ywx.customer.dao.po.FirmUsercertChannelExample;
//import com.trust.ywx.customer.service.dto.TrustFirmDto;
//import com.trust.ywx.customer.common.model.query.request.SearchCrmFirmParam;
//import com.trust.ywx.customer.common.model.query.request.SearchFirmParam;
//import com.trust.ywx.customer.common.model.query.request.SearchTrustFirmWithPageParam;
//import com.trust.ywx.customer.service.dto.response.AuditFirmDto;
//import com.trust.ywx.customer.common.model.query.response.CrmFirmDto;
//import com.trust.ywx.customer.common.exception.BizException;
//import com.trust.ywx.customer.service.query.FirmQueryService;
//import org.apache.commons.lang.StringUtils;
//import org.springframework.beans.BeanUtils;
//import org.springframework.beans.factory.annotation.Autowired;
//import org.springframework.util.CollectionUtils;
//
//import java.util.ArrayList;
//import java.util.List;
//import java.util.Map;
//import java.util.Objects;
//
///**
// * <pre></pre>
// *
// * @文件名称： FirmQueryServiceImpl.java
// * @包 路  径： com.trust.ywx.customer.service.impl
// * @Copyright：北京数字医信责任有限公司 (C) 2022 *
// * @Description:
// * @Version: V1.0
// * @Author： hanzhenchao
// * @Date：2022/6/15 18:43
// * @Modify：
// */
//public class FirmQueryServiceImpl_bak implements FirmQueryService {
//    @Autowired
//    private FirmDao firmDao;
//    @Autowired
//    private FirmGroupDao firmGroupDao;
//    @Autowired
//    private FirmExtendDao firmExtendDao;
//    @Autowired
//    private FirmUsercertChannelMapper usercertChannelMapper;
//
//    @Override
//    public PageList<List<TrustFirmDto>> getTrustFirmList(SearchTrustFirmWithPageParam param) {
//        List<String> clientIdList = new ArrayList<>();
//
//        // 客户id/合同编号/合同方 筛选
//        if(!Objects.equals(param.getClientId(),param.getLikeCron())){
//            // 如果clientId不为空，比较likeCron是否一致，不一致说明likeCron是合同编号/合同方
//            if(StringUtils.isNotEmpty(param.getLikeCron())){
//                //查询合同表
//                String clientId = firmDao.getClientIdByKeyword(param.getLikeCron());
//                if(StringUtils.isEmpty(clientId) || !Objects.equals(param.getClientId(),clientId)){
//                    // 未查到或查到的clientId和选择的客户不匹配，返回空
//                    return new PageList();
//                }
//            }
//        }
//
//        // clientId筛选
//        if(StringUtils.isNotEmpty(param.getClientId())){
//            FirmInfo firmInfo = firmDao.getFrimByClientId(param.getClientId());
//            if(null == firmInfo){
//                return new PageList();
//            }
//            // 增加项目状态的判断
//            if(null != param.getFirmStatus() && Objects.equals(firmInfo.getFirmStatus(),param.getFirmStatus())){
//                return new PageList();
//            }
//            clientIdList.add(param.getClientId());
//
//        }
//
//        // 客户组筛选
//        if(StringUtils.isNotEmpty(param.getGroupId())){
//            List<String> groupClientIdList = firmGroupDao.getClientIdByGroupId(param.getGroupId());
//            if(CollectionUtils.isEmpty(clientIdList)){
//                clientIdList = groupClientIdList;
//            }else{
//                clientIdList.retainAll(groupClientIdList);
//                if(CollectionUtils.isEmpty(clientIdList)){
//                    return new PageList();
//                }
//            }
//        }
//
//        // 医师产品形态筛选（fixme，目前单独存储在firm_usercert_channel表，后期挪到firm_info_extends表）
//        if(null!=param.getDoctorProductType()){
//            if(StringUtils.isNotEmpty(param.getClientId())){
//                // 携带客户Id和产品形态一起去查
//                FirmUsercertChannelExample example = new FirmUsercertChannelExample();
//                example.createCriteria().andChannelTypeEqualTo(param.getDoctorProductType()).andClientidEqualTo(param.getClientId());
//                long count = usercertChannelMapper.countByExample(example);
//                if(count==0){
//                    return new PageList();
//                }else{
//                    clientIdList.add(param.getClientId());
//                }
//            }else{
//                List<String> subClientIdList = firmDao.getClientIdByChannelType(param.getDoctorProductType());
//                // 与clientIdList求并集
//                clientIdList.retainAll(subClientIdList);
//                if(CollectionUtils.isEmpty(clientIdList)){
//                    return new PageList();
//                }
//            }
//        }
//
//        /**
//         * 属性过滤暂时没想到好办法，只能一个个去查询了
//         */
//        if(null!=param.getNetworkType()){
//            List<String> subClientIdList = firmExtendDao.getByPropsAndClientId(FirmProperEnum.NETWORK_TYPE.getProperName(),NetworkTypeEnum.getNameOfCode(param.getNetworkType()),clientIdList);
//            // 与clientIdList求并集
//            clientIdList.retainAll(subClientIdList);
//            if(CollectionUtils.isEmpty(clientIdList)){
//                return new PageList();
//            }
//        }
//        if(null!=param.getChargingMode()){
//            List<String> subClientIdList = firmExtendDao.getByPropsAndClientId(FirmProperEnum.CHARGING_MODEL.getProperName(), param.getChargingMode()+"", clientIdList);
//            // 与clientIdList求并集
//            clientIdList.retainAll(subClientIdList);
//            if(CollectionUtils.isEmpty(clientIdList)){
//                return new PageList();
//            }
//        }
//        if(null!=param.getPublicProductType()){
//            List<String> subClientIdList = firmExtendDao.getByPropsAndClientId(FirmProperEnum.PUBLIC_PRODUCT_TYPE.getProperName(),param.getPublicProductType()+"",clientIdList);
//            // 与clientIdList求并集
//            clientIdList.retainAll(subClientIdList);
//            if(CollectionUtils.isEmpty(clientIdList)){
//                return new PageList();
//            }
//        }
//
//
//        List<FirmInfo> firmList = firmDao.getListByIds(clientIdList);
//        List<TrustFirmDto> dtoList = new ArrayList<>(firmList.size());
//        for (FirmInfo po: firmList) {
//            TrustFirmDto dto = converPoToDto(po);
//            dtoList.add(dto);
//        }
//
//        // fixme 组装好麻烦，需要改进下
//        PageList pageList = new PageList();
//        pageList.setItems(dtoList);
//        Page page = new Page();
//        page.setPageNo(param.getPageNo());
//        page.setPageSize(param.getPageSize());
//        page.setTotal(dtoList.size());
//        pageList.setPage(page);
//        return pageList;
//    }
//
//
//    private TrustFirmDto converPoToDto(FirmInfo po) {
//        if(null == po){
//            return null;
//        }
//        TrustFirmDto dto = new TrustFirmDto();
//        BeanUtils.copyProperties(po,dto);
//
//        // TODO 差异属性转换
//        return dto;
//    }
//
//    @Override
//    public TrustFirmDto getTrustFirm(String clientId) {
//        return null;
//    }
//
//    @Override
//    public Map<String, String> getProp(String clientId) throws Exception{
//        if(StringUtils.isEmpty(clientId)){
//            throw new BizException("400","clientId不能为空");
//        }
//        // 从firm_info_extend\、firm_usercert_channel获取全量属性
//
//        return null;
//    }
//
//    @Override
//    public List<AuditFirmDto> getAuditFirmList(SearchFirmParam param) {
//        return null;
//    }
//
//    @Override
//    public List<CrmFirmDto> getCrmFirmList(SearchCrmFirmParam param) {
//        return null;
//    }
//}
