package com.trust.ywx.customer;

import com.fiftyonetrust.common.util.JsonUtil;
import com.trust.ywx.customer.dao.mapper.FirmInfoMapper;
import com.trust.ywx.customer.dao.po.FirmInfo;
import com.trust.ywx.customer.dao.po.FirmInfoExample;
import lombok.extern.slf4j.Slf4j;
import org.junit.jupiter.api.Test;
import org.springframework.boot.test.context.SpringBootTest;

import javax.annotation.Resource;
import java.util.List;

@Slf4j
@SpringBootTest(classes = Application.class)
class ApplicationTests {

    @Resource
    FirmInfoMapper firmInfoMapper;
    @Test
    void contextLoads() {
        FirmInfoExample example = new FirmInfoExample();
        example.limit(1);
        List<FirmInfo> a = firmInfoMapper.selectByExample(example);
        System.out.println(JsonUtil.of(a));
    }

}
