package com.trust.ywx.customer.common.enu;
/***************************************************************************
 * <pre></pre>
 * @文件名称:  CachannelEnum.java
 * @包   路   径：  cn.org.bjca.ywq.firm.cons
 * @版权所有：北京数字认证股份有限公司 (C) 2018
 *
 * @类描述:
 * @版本: V1.5
 * @创建人： wujunpeng
 * @创建时间：2021年3月9日 下午7:36:58
 *
 * @修改记录：
 **/
public enum FirmStampEnum {
    ROUND (0,"圆章"),
    SQUARE (1,"方章"),
    ;

    private int code;
    private String name;

    FirmStampEnum(int channel, String dec) {
        this.code = channel;
        this.name = dec;
    }

    // 普通方法
    public static String getName(int code) {
        for (FirmStampEnum t : FirmStampEnum.values()) {
            if (t.getCode() == code) {
                return t.getName();
            }
        }
        return null;
    }

    public int getCode() {
        return code;
    }

    public String getName() {
        return name;
    }
}
