package com.trust.ywx.customer.common.enu;

/**
 * <pre></pre>
 *
 * @文件名称： FirmStatusEnum.java
 * @包 路  径： com.trust.ywx.customer.common.enu
 * @Copyright：北京数字医信责任有限公司 (C) 2022 *
 * @Description:
 * @Version: V1.0
 * @Author： hanzhenchao
 * @Date：2022/6/21 11:34
 * @Modify：
 */
public enum FirmStatusEnum {
    FIRM_SUB_NORMAL(1, "正常"),
    FIRM_SUB_USEUP(2, "用尽"),
    FIRM_SUB_STOP(3, "停用"),
    FIRM_SUB_DELETE(4, "删除"),
    FIRM_SUB_EXCESS(5, "过量"),
    FIRM_SUB_TIMEOUT(6, "过期"),
    FIRM_SUB_NOCONTRACT_AUTO_STOP(7, "未签约自动强制停止"),
    FIRM_SUB_OVER_AUTO_STOP(8, "超出自动强制停止");

    private int code;
    private String dec;

    private FirmStatusEnum(int code, String dec) {
        this.code = code;
        this.dec = dec;
    }

    public static String getDesc(int code) {
        FirmStatusEnum[] var1 = values();
        int var2 = var1.length;

        for(int var3 = 0; var3 < var2; ++var3) {
            FirmStatusEnum t = var1[var3];
            if (t.code == code) {
                return t.getDec();
            }
        }

        return null;
    }

    public int getCode() {
        return this.code;
    }

    public String getDec() {
        return this.dec;
    }
}
