package com.trust.ywx.customer.common.enu;
/**
 * *************************************************************************
 * <pre></pre>
 * @文件名称:  FirmStatus.java
 * @包   路   径：  cn.org.bjca.ywq.config.common.status
 * @版权所有：北京数字认证股份有限公司 (C) 2017
 *
 * @类描述:  厂商状态枚举
 * @版本: V1.0
 * @创建人： hudan
 * @创建时间：2017年1月22日 上午10:42:38
 * @修改记录：
 */
public enum TempFirmStatusEnum {

	//可信任客户
	FIRM_RIGHT(1,"正常"),
	FIRM_STOP(3,"停用"),
	FIRM_CREATE_STAMP(5,"已制章"),

	// 临时客户
	TEMP_UNAUTHEN(0,"未审核"),
	TEMP_PASS(1,"审核通过"),
	TEMP_REFUSE(2,"拒绝"),
	TEMP_DEL(4, "删除")
	;
	
	private int code;
	private String dec;
	private TempFirmStatusEnum(int code, String dec) {
		this.code = code;
		this.dec = dec;
	}
	public int getCode() {
		return code;
	}

}
