package com.trust.ywx.customer.common.exception;

import com.trust.ywx.customer.common.enu.FirmErrEum;

/**
 * <pre></pre>
 *
 * @文件名称： BizException.java
 * @包 路  径： com.trust.ywx.customer.service.exceptions
 * @Copyright：北京数字医信责任有限公司 (C) 2022 *
 * @Description: 客户服务返回的业务异常
 * @Version: V1.0
 * @Author： hanzhenchao
 * @Date：2022/6/11 21:15
 * @Modify：
 */
public class BizException extends Exception {
    private static final long serialVersionUID = -1379865823677107053L;
    private String status;

    public BizException(String status, String message) {
        super(message);
        this.status = status;
    }

    public BizException(FirmErrEum enu) {
        super(enu.getMessage());
        this.status = enu.getMessage();
    }

    public String getStatus() {
        return status;
    }

    public String getMessage(){
        return super.getMessage();
    }
}
