package com.trust.ywx.customer.common.model.query.response;

import lombok.Data;

import java.io.Serializable;
import java.util.Date;
import java.util.List;

/**
 * <pre></pre>
 *
 * @文件名称： AuditCustomerDto.java
 * @包 路  径： com.trust.ywx.customer.service.dto
 * @Copyright：北京数字医信责任有限公司 (C) 2022 *
 * @Description: 北京Ca客户
 * @Version: V1.0
 * @Author： hanzhenchao
 * @Date：2022/6/14 20:15
 * @Modify：
 */
@Data
public class CrmFirmDto implements Serializable {
    private String agentClientId;
    /*CRM订单id*/
    private String orderId;
    /*原始订单id*/
    private String originalOrderId;
    /*订单类型*/
    private String orderType;
    /*合同编号*/
    private String contractCode;
    /*合同名称*/
    private String contractName;
    /*合同链接*/
    private String contractUrl;
    /*申请人姓名*/
    private String applicantName;
    /*申请人部门*/
    private String applicantDepartment;
    /*申请人邮箱*/
    private String applicantEmail;
    /*申请人电话*/
    private String applicantPhone;
    /*申请人所属中心*/
    private String applicantRegion;
    /*客户编号*/
    private String crmCustomerId;
    /*客户名称*/
    private String customerName;
    /*客户统一信用代码*/
    private String customerUniqueCode;
    /*客户联系人*/
    private String customerContact;
    /*客户电话*/
    private String customerPhone;
    /*客户邮箱*/
    private String customerEmail;
    /*客户通讯地址*/
    private String customerAddress;
    /*客户行业*/
    private String customerIndustry;
    /*客户省份*/
    private String province;
    /*项目编号*/
    private String projectCode;
    /*项目名称*/
    private String projectName;
    /*是否立项 YES是 NO否*/
    private String projectFlag;
    /*业务信息列表*/
    private List<OrderBusiness> businessList;
    /*归还订单列表JSON串*/
    private String revertOrderId;
    /*甲方名称*/
    private String partyaName;
    /*订单属性*/
    private String orderAttribute;
    /*是否纯证书订单*/
    private String isCertOrder;
    /*收货人信息列表*/
//    private List<OrderReceiver> receiverList;
    /*状态 0 待确认 1已确认*/
    private Integer status;
    /*厂商id*/
    private String clientId;

    private Date createTime;

    private Date updateTime;

    private String remarks;
}
