package com.trust.ywx.customer.common.model.query.response;

import lombok.Data;

import java.io.Serializable;

/***************************************************************************
 * <pre></pre>
 *
 * @文件名称: OrderBusiness.java
 * @包 路 径： cn.org.bjca.ywq.firm.mongobean
 * @版权所有：北京数字医信科技有限公司 (C) 2019
 *
 * @类描述:
 * @版本: V1.5 @创建人： 吴俊鹏
 * @创建时间：2020-5-20 16:23
 ***************************************************************************/
@Data
public class OrderBusiness implements Serializable {
    /*crm系统客户编号*/
    private String crmBusinessId;

    /*产品型号*/
    private String businessCode;
    private String businessName;
    private String billingMethod;
    private String billingType;

    private String settlementType;
    // fixme
//    @JSONField(deserializeUsing =MongoLongConverter.class )
    private Long quantity;

    /*金额 单位：分*/
//    @JSONField(deserializeUsing = MongoLongConverter.class )
    private Long amount;

    /*单价 单位：分*/
//    @JSONField(deserializeUsing =MongoLongConverter.class )
    private Long unitPrice;

    private String remark;

    /*服务期限不能为空 单位：月*/
    private Integer serviceTerm;

    /*产品类型*/
    private String type;

    /*服务开通时间*/
    private String startDate;
}