package com.trust.ywx.customer.dao.mapper.custom;

import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;
import java.util.Map;

/**
 * <pre></pre>
 *
 * @文件名称： FirmCustomMapper.java
 * @包 路  径： com.trust.ywx.customer.dao.mapper.custom
 * @Copyright：北京数字医信责任有限公司 (C) 2022 *
 * @Description:
 * @Version: V1.0
 * @Author： hanzhenchao
 * @Date：2022/6/16 11:08
 * @Modify：
 */
@Mapper
public interface FirmCustomMapper {
    /**
     * 根据合同关键字获取客户id
     * @param keyword
     * @return
     */
    String getClientIdByKeyword(@Param("keyword") String keyword);

    /**
     * 根据channelType（ 医师产品形态）获取客户id
     * @param channelType
     * @return
     */
    List<String> getClientIdByChannelType(@Param("channelType") int channelType);


}
